#include "ancestral.h"

void chooseSeq(char *listFile, int number);
void chooseSeq1(char *listFile, int number);
void histgram(char *seqFile, int lowBoundItem, int pickItem, char *alnFile);
void alpha();

struct IDENTITY {
	int LPoint;
	int RPoint;
	double identity;
	bool LClusterFlag;
	bool RClusterFlag;
};


NODE *node;
FILE *resultFile=stdout;
int seqNum, seqLength;
double **S_ij,**Q_ij,*PI,**sitePI;
double *alfa;
//used for calculate the eignvalue and eignvector of matrix Q
double **a, **v, **inv, *wr, *wi, *w, **svdv, *colu;
bool *dashFlag,*calFlag;
char aa[NP+1]={'-','A','R','N','D','C','Q','E','G','H','I','L','K','M','F','P','S','T','W','Y','V'};
long idum=(-64);
void usage()
{
	printf("Usage: chooseSeq -i sequencefile -L (1~7) -C (1~4) -o output alignment\n");
	exit(1);
}


int main(int argc, char **argv)
{
	int i;
	int site;
	FILE *input;
	char seqFile[20], treeFile[20], alnFile[40];
	bool histFlag=false,seqFlag=false;
	int lowBoundItem=0, pickItem=0;

	//initiate the matrix and vectors
	S_ij=dmatrix(1,NP,1,NP);
	Q_ij=dmatrix(1,NP,1,NP);
	PI=dvector(1,NP);
	a=dmatrix(1,NP,1,NP);//copy matrix Q will be destroyed
	v=dmatrix(1,NP,1,NP);//store eignvector matrix
	inv=dmatrix(1,NP,1,NP);//store inverse of eignvector matrix
	wr=dvector(1,NP);//store eignvalue
	wi=dvector(1,NP);//store eignvalue
	w=dvector(1,NP);//used for SVD algo
	svdv=dmatrix(1,NP,1,NP);//used for SVD algo
	colu=dvector(1,NP);//used for inverse of eignvector matrix

	if(argc<=1) usage();
	for(i=1;i<argc;++i){
		char option,optidx;
		if(argv[i][0]=='-') option=argv[i][1];
		else usage();
		switch(option){
			case 'H':
				histFlag=true;
				break;
			case 'S':
				seqFlag=true;
				break;
			case 'i':
				++i;
				optidx=0;
				if(i<argc) {
					strcpy(seqFile,argv[i]);
					input=fopen(seqFile,"r");
					if(!input) {
						printf("can not open file:%s\n",seqFile);
						exit(1);
					}
					fclose(input);
				}
				else usage();
				break;
			case 'L':
				++i;
				optidx=0;
				if(i<argc) {
					lowBoundItem=atoi(argv[i]);
					if(lowBoundItem<1 || lowBoundItem>7) {printf("L parameter is wrong\n"); usage(); }
				}
				else usage();
				break;
			case 'C':
				++i;
				optidx=0;
				if(i<argc) {
					pickItem=atoi(argv[i]);
					if(pickItem<1 || pickItem>4) {printf("C parameter is wrong\n"); usage(); }
				}
				else usage();
				break;
			case 'o':
				++i;
				optidx=0;
				if(i<argc){
					strcpy(alnFile,argv[i]);
				}
				else usage();
				break;
			case 'l':
				++i;
				optidx=0;
				if(i<argc) {
					strcpy(treeFile,argv[i]);
					input=fopen(treeFile,"r");
					if(!input) {
						printf("can not open file:%s\n",treeFile);
						exit(1);
					}
					fclose(input);
				}
				else usage();
				break;
			case 'n':
				++i;
				optidx=0;
				if(i<argc) {
					site=atoi(argv[i]);
					if(site<=0) {
						printf("site should be greater than 0\n");
						exit(1);
					}
				}
				else usage();
				break;
			default:
				usage();
		}
	}

	//read S_ij matrix
	init_S();
	readali(seqFile);
	if(histFlag) histgram(seqFile,lowBoundItem,pickItem,alnFile);
	if(seqFlag) chooseSeq1(treeFile,site);
}


void histgram(char *seqFile, int lowBoundItem, int pickItem, char *alnFile)
{
	printf("Begin histgram, seqNum: %d\n",seqNum);
	int i,j,k;
	double **idMatrix;
	idMatrix=dmatrix(1,seqNum,1,seqNum);
//	char outFile[20],outFile1[20];
	char recFile[50];
	strcpy(recFile,alnFile);
//	recFile[strlen(recFile)-3]='\0';
	for(i=strlen(recFile);i>=0;i--) if(recFile[i]=='.') { recFile[i+1]='\0'; break; }
	strcat(recFile,"rec");
	FILE *output,*output1;
	printf("after define idmatrix\n");
/*
	for(i=0;i<20;i++){
		if(seqFile[i]!='.') {
			outFile[i]=seqFile[i];
		}
		else { outFile[i]='\0'; break;}
	}
	strcpy(outFile1,outFile);
	strcat(outFile,"_1.aln");
	strcat(outFile1,"_2.aln");
*/
	output1=fopen(recFile,"w");

	for(i=1;i<seqNum;i++){
		for(j=i+1;j<=seqNum;j++){
			int count=0; int length=0;
			for(k=1;k<=seqLength;k++){
				if((node[i].seq_aa[k]!='-')&&(node[i].seq_aa[k]!='.')&&(node[j].seq_aa[k]!='-')&&(node[j].seq_aa[k]!='.')){
					length++;
					if(node[i].seq_aa[k]==node[j].seq_aa[k]) count++;
				}
			}
			if(length>0) idMatrix[i][j]=1.0*count/length;
			else idMatrix[i][j]=0.0;
		}
	}
	int *binCount;
	binCount=ivector(1,20);
	for(i=1;i<=20;i++) binCount[i]=0;
	int tmpCount=0;
	for(i=1;i<seqNum;i++){
		for(j=i+1;j<=seqNum;j++){
//			printf("%3.0f\n",idMatrix[i][j]*100.0);
			tmpCount++;
			for(k=0;k<=19;k++){
				if((idMatrix[i][j]>=k*0.05)&&(idMatrix[i][j]<(k+1)*0.05)) {
					binCount[k+1]++;
					break;
				}
				else if(idMatrix[i][j]>0.95) {
					binCount[20]++;
					break;
				}
//				if(idMatrix[i][j]<0.0)  printf("Warning\n");
			}
		}
	}
	fprintf(output1,"seqNum: %d  total number of pairs: %d  tmpCount:%d\n",seqNum,seqNum*(seqNum-1)/2,tmpCount);
	for(i=1;i<=20;i++) fprintf(output1,"%5d\n",binCount[i]);

	//find the highBound and lowBound
	double highBound=0.8;
	double lowBound=0.0;
	double biggest=0.0; int row,col;
	for(i=1;i<seqNum;i++) for(j=i+1;j<=seqNum;j++) if(biggest<idMatrix[i][j]) {biggest=idMatrix[i][j]; row=i; col=j; }
	int *cluster,clusterIndex=1;
	cluster=ivector(1,seqNum);
	for(i=1;i<=seqNum;i++) cluster[i]=0;

	//prepare matrix of identity
	double **idCopy;
	idCopy=dmatrix(1,seqNum,1,seqNum);
	for(i=1;i<seqNum;i++) for(j=i+1;j<=seqNum;j++) idCopy[i][j]=idMatrix[i][j];
	for(i=1;i<seqNum;i++) for(j=i+1;j<=seqNum;j++) idCopy[j][i]=idCopy[i][j];
	for(i=1;i<=seqNum;i++) idCopy[i][i]=0.0;

	//test
/*	for(i=1;i<=seqNum;i++){
		for(j=1;j<=seqNum;j++) printf("%3d ",(int) (idCopy[i][j]*1000.0));
		printf("\n");
	}
*/
	fprintf(output1,"highBound: %3d lowBound: %3d\n",(int) (1000.0*highBound),(int) (1000.0*lowBound));
	//cluster with highBound
	while(biggest>=highBound){
//		printf("biggest: %3d  clusterIndex:%d\n",(int) (biggest*1000.0),clusterIndex);
		if((cluster[row]==0)&&(cluster[col]==0)){
			cluster[row]=cluster[col]=clusterIndex;
			clusterIndex++;
		}
		else if(cluster[row]==0) cluster[row]=cluster[col];
		else if(cluster[col]==0) cluster[col]=cluster[row];
		else {
			int changeFrom,changeTo;
			if(cluster[row]<cluster[col]) {changeFrom=cluster[col]; changeTo=cluster[row]; }
			else { changeFrom=cluster[row]; changeTo=cluster[col]; }
			if(changeFrom!=changeTo){
//				printf("cluster:%4d and cluster:%4d combine together\n",changeFrom,changeTo);

				for(i=1;i<=seqNum;i++){
					if(cluster[i]==changeFrom) cluster[i]=changeTo;
				}

				for(i=1;i<=seqNum;i++) if(cluster[i]>changeFrom) cluster[i]--;
				clusterIndex--;
			}

		}
		//change the matrix
		idCopy[row][col]=idCopy[col][row]=0.0;
/*
		for(i=1;i<row;i++){
			if(idCopy[i][row]<idCopy[i][col]) idCopy[i][col]=0.0;
			else { idCopy[i][row]=idCopy[i][col]; idCopy[i][col]=0.0; }
		}
		for(i=col+1;i<=seqNum;i++){
			if(idCopy[row][i]<idCopy[col][i]) idCopy[col][i]=0.0;
			else { idCopy[row][i]=idCopy[col][i]; idCopy[col][i]=0.0; }
		}
		for(i=row+1;i<=col-1;i++){
			if(idCopy[row][i]<idCopy[i][col]) idCopy[i][col]=0.0;
			else { idCopy[row][i]=idCopy[i][col]; idCopy[i][col]=0.0; }
		}
*/
		//test
/*		printf("row:%3d  col:%3d  biggest:%3d\n",row,col,(int)(biggest*1000.0));
		for(i=1;i<=seqNum;i++){
			for(j=1;j<=seqNum;j++) printf("%3d ",(int) (idCopy[i][j]*1000.0));
			printf("\n");
		}
		printf("\n");
*/
		//find the biggest
		biggest=0.0; row=col=0;
		for(i=1;i<seqNum;i++){
			for(j=i+1;j<=seqNum;j++){
				if(idCopy[i][j]>biggest) {
					biggest=idCopy[i][j];
					row=i; col=j;
				}
			}
		}
	}
	//test
	fprintf(output1,"clusterIndex:%d\n",clusterIndex);
	for(i=0;i<clusterIndex;i++){
		fprintf(output1,"Cluster %d : ",i);
		for(j=1;j<=seqNum;j++)	if(cluster[j]==i) fprintf(output1,"%d ",j);
		fprintf(output1,"\n");
	}
	int clusterNumber=clusterIndex-1;
	for(j=1;j<=seqNum;j++) if(cluster[j]==0) clusterNumber++;
	fprintf(output1,"Total cluster number: %d\n",clusterNumber);

	//pick sequences with longest non-gap length
	//define cluster
	int **group;
//	if(clusterIndex<500) group=imatrix(1,500,1,seqNum);
	group=imatrix(1,clusterIndex-1,1,seqNum);
	int *groupIndex;
//	if(clusterIndex<500) groupIndex=ivector(1,500);
	groupIndex=ivector(1,clusterIndex-1);
	for(i=1;i<clusterIndex;i++) groupIndex[i]=1;
	for(i=1;i<clusterIndex;i++){
		for(j=1;j<=seqNum;j++){
			if(cluster[j]==i) group[i][groupIndex[i]++]=j;
		}
	}
	//find the site gap flag;
	bool *siteFlag;
	siteFlag=new bool [seqLength+1];
	for(i=1;i<=seqLength;i++){
		int count=0;
		for(j=1;j<=seqNum;j++){
			if(node[j].seq_aa[i]=='.'||node[j].seq_aa[i]=='-') count++;
		}
		if(2*count>seqNum) siteFlag[i]=true;
		else siteFlag[i]=false;
	}
	//pick up sequence
	for(i=1;i<clusterIndex;i++){
		int *groupCount;
		groupCount=ivector(1,groupIndex[i]-1);
		for(j=1;j<groupIndex[i];j++){
			groupCount[j]=0;
			for(k=1;k<=seqLength;k++){
				if(!siteFlag[k]){
					if(node[group[i][j]].seq_aa[k]!='.' && node[group[i][j]].seq_aa[k]!='-')
						groupCount[j]++;
				}
			}
//			printf("%d ",groupCount[j]);
		}
		//find the longest
		int longest=0; int longestIndex=0;
		for(j=1;j<groupIndex[i];j++) if(longest<groupCount[j]) {longest=groupCount[j]; longestIndex=j; }
		if(longestIndex==0) { printf("warning: there is wrong with picking sequence from group: %d\n",i); exit(0); }
		group[i][groupIndex[i]]=group[i][longestIndex];
//		printf("\n longest:%d\n",group[i][groupIndex[i]]);
		free_ivector(groupCount,1,groupIndex[i]-1);
	}
	//find maximum, minimum and average of identity for each group
	double *highMax,*highMin,*highAvg;
	highMax=dvector(1,clusterIndex-1);
	highMin=dvector(1,clusterIndex-1);
	highAvg=dvector(1,clusterIndex-1);
	for(i=1;i<clusterIndex;i++) { highMax[i]=0.0; highMin[i]=100.0; highAvg[i]=0.0; }
	for(i=1;i<clusterIndex;i++){
		for(j=1;j<groupIndex[i]-1;j++){
			for(k=j+1;k<groupIndex[i];k++){
				highAvg[i]+=idMatrix[group[i][j]][group[i][k]];
				if(highMax[i]<idMatrix[group[i][j]][group[i][k]]) highMax[i]=idMatrix[group[i][j]][group[i][k]];
				if(highMin[i]>idMatrix[group[i][j]][group[i][k]]) highMin[i]=idMatrix[group[i][j]][group[i][k]];
			}
		}
		highAvg[i]=highAvg[i]/((groupIndex[i]-1)*(groupIndex[i]-2)/2.0);
	}
	for(i=1;i<clusterIndex;i++){
		fprintf(output1,"cluster:%3d Max ID:%4.0f  Min ID:%4.0f Avg ID:%4.0f\n",i,highMax[i]*1000.0,highMin[i]*1000.0,highAvg[i]*1000.0);
	}

	printf("after single linkage\n");
	int *cluster1;
	cluster1=ivector(1,seqNum);
	for(i=1;i<=seqNum;i++) cluster1[i]=cluster[i];
	for(i=1;i<clusterIndex;i++) cluster1[group[i][groupIndex[i]]]=0;
	//delete sequence
	for(i=1;i<=seqNum;i++) {
		if(cluster1[i]!=0) {
			while(cluster1[seqNum]!=0) {seqNum--;}
			node[i]=node[seqNum];
			seqNum--;
		}
	}
	free_dvector(highMax,1,clusterIndex-1);
	free_dvector(highMin,1,clusterIndex-1);
	free_dvector(highAvg,1,clusterIndex-1);
	printf("after delete sequences after single linkage\n");

	//find dashFlag and calFlag
	int totalAA;
	calFlag=new bool [seqLength+1];
	for(i=1;i<=seqLength;i++){
		calFlag[i]=false;
		totalAA=0;
		for(j=1;j<=seqNum;j++){
			if(node[j].seq_aa[i]!='-') totalAA++;
		}
		if(totalAA>=3) calFlag[i]=true;
	}

	printf("before calculate PI\n");
	cal_PI();
	printf("after calculate PI\n");


	cal_Q(PI);//calculate PI vector and Q(ij) matrix
	printf("after calculate Q\n");
	cal_Eign();//calculate eignvalue vector and eignvector matrix of Q(ij)
	printf("after calculate Eign\n");
	alpha(); //calculate Alignment Based Alpha (AB alpha)
	printf("after calculate alpha\n");

	//copy identity matrix
	for(i=1;i<seqNum;i++) for(j=i+1;j<=seqNum;j++) idMatrix[i][j]=idCopy[i][j]=dist(i,j);
	for(i=1;i<seqNum;i++) for(j=i+1;j<=seqNum;j++) idCopy[j][i]=idCopy[i][j];
	for(i=1;i<seqNum;i++) idCopy[i][i]=0.0;
/*	for(i=1;i<=seqNum;i++) {
		fprintf(output1,"%20s ",node[i].nodeName);
		for(j=1;j<=seqNum;j++) fprintf(output1,"%8.5f ",idMatrix[i][j]);
		fprintf(output1,"\n");
	}
*/
	printf("after calculate dist matrix\n");
	//change cluster vector and idCopy
	for(i=1;i<=seqNum;i++) for(j=1;j<=i;j++) idCopy[i][j]=100.0;
	//calculate the lowbound
	lowBound=0.0;
	for(i=1;i<seqNum;i++) for(j=i+1;j<=seqNum;j++) lowBound+=idCopy[i][j];
	lowBound=0.6*lowBound/(seqNum*(seqNum-1)/2);
	fprintf(output1,"lowBound: %6.0f\n",lowBound*1000);

	//free group and groupIndex
	free_imatrix(group,1,clusterIndex-1,1,seqNum);
	free_ivector(groupIndex,1,clusterIndex-1);
	//cluster with low bound
	for(i=1;i<=seqNum;i++) cluster[i]=0;
	//find the smallest
	biggest=1000.0; row=col=0;
	for(i=1;i<seqNum;i++){
		for(j=i+1;j<=seqNum;j++) if(idCopy[i][j]<biggest){ biggest=idCopy[i][j]; row=i;col=j; }
	}
	clusterIndex=1;
	while(biggest<=lowBound){
		if((cluster[row]==0)&&(cluster[col]==0)){
			cluster[row]=cluster[col]=clusterIndex;
			clusterIndex++;
		}
		else if(cluster[row]==0) cluster[row]=cluster[col];
		else if(cluster[col]==0) cluster[col]=cluster[row];
		else {
			int changeFrom,changeTo;
			if(cluster[row]<cluster[col]) {changeFrom=cluster[col]; changeTo=cluster[row]; }
			else { changeFrom=cluster[row]; changeTo=cluster[col]; }
			if(changeFrom!=changeTo){
//				printf("cluster:%4d and cluster:%4d combine together\n",changeFrom,changeTo);

				for(i=1;i<=seqNum;i++){
					if(cluster[i]==changeFrom) cluster[i]=changeTo;
				}

				for(i=1;i<=seqNum;i++) if(cluster[i]>changeFrom) cluster[i]--;
				clusterIndex--;
			}

		}
		//change the matrix
		idCopy[row][col]=100.0;

		for(i=1;i<row;i++){
			if(idCopy[i][row]>idCopy[i][col]) idCopy[i][col]=100.0;
			else { idCopy[i][row]=idCopy[i][col]; idCopy[i][col]=100.0; }
		}
		for(i=col+1;i<=seqNum;i++){
			if(idCopy[row][i]>idCopy[col][i]) idCopy[col][i]=100.0;
			else { idCopy[row][i]=idCopy[col][i]; idCopy[col][i]=100.0; }
		}
		for(i=row+1;i<=col-1;i++){
			if(idCopy[row][i]>idCopy[i][col]) idCopy[i][col]=100.0;
			else { idCopy[row][i]=idCopy[i][col]; idCopy[i][col]=100.0; }
		}

		//test
/*		printf("row:%3d  col:%3d  biggest:%3d\n",row,col,(int)(biggest*1000.0));
		for(i=1;i<=seqNum;i++){
			for(j=1;j<=seqNum;j++) printf("%3d ",(int) (idCopy[i][j]*1000.0));
			printf("\n");
		}
		printf("\n");
*/
		//find the biggest
		biggest=100.0; row=col=0;
		for(i=1;i<seqNum;i++){
			for(j=i+1;j<=seqNum;j++){
				if(idCopy[i][j]<biggest) {
					biggest=idCopy[i][j];
					row=i; col=j;
				}
			}
		}
	}

	//assign group and groupIndex
	group=imatrix(1,clusterIndex-1,1,seqNum);
	groupIndex=ivector(1,clusterIndex-1);
	//statistics analysis
	for(i=1;i<clusterIndex;i++) groupIndex[i]=1;
	for(i=1;i<clusterIndex;i++){
		for(j=1;j<=seqNum;j++){
			if(cluster[j]==i) group[i][groupIndex[i]++]=j;
		}
	}
//	for(i=1;i<clusterIndex;i++) { highMax[i]=0.0; highMin[i]=100.0; highAvg[i]=0.0; }
	highMax=dvector(1,clusterIndex-1);
	highMin=dvector(1,clusterIndex-1);
	highAvg=dvector(1,clusterIndex-1);
	for(i=1;i<clusterIndex;i++){
		highMax[i]=0.0; highMin[i]=100.0; highAvg[i]=0.0;
		for(j=1;j<groupIndex[i]-1;j++){
			for(k=j+1;k<groupIndex[i];k++){
				highAvg[i]+=idMatrix[group[i][j]][group[i][k]];
				if(highMax[i]<idMatrix[group[i][j]][group[i][k]]) highMax[i]=idMatrix[group[i][j]][group[i][k]];
				if(highMin[i]>idMatrix[group[i][j]][group[i][k]]) highMin[i]=idMatrix[group[i][j]][group[i][k]];
			}
		}
		highAvg[i]=highAvg[i]/((groupIndex[i]-1)*(groupIndex[i]-2)/2.0);
	}
	for(i=1;i<clusterIndex;i++){
		fprintf(output1,"cluster:%3d Max ID:%8.5f  Min ID:%8.5f Avg ID:%8.5f\n",i,highMax[i],highMin[i],highAvg[i]);
	}
	//histogram of number of members in each cluster
	//find the largest number
	int largest=0,largest0;
	for(i=1;i<=seqNum;i++) if(cluster[i]==0) largest++;
	largest0=largest;
	for(i=1;i<clusterIndex;i++){
		if(largest<groupIndex[i]-1) largest=groupIndex[i]-1;
	}
	int *lowBin;
	lowBin=ivector(1,largest);
	lowBin[1]=largest0;
	for(i=2;i<=largest;i++) lowBin[i]=0;
	for(j=1;j<clusterIndex;j++) lowBin[groupIndex[j]-1]++;
//	for(i=1;i<=largest;i++) printf("%d\n",lowBin[i]*i);

	//test
	int *clusterCount; clusterCount=ivector(1,clusterIndex-1);
	int *clusterCountIndex; clusterCountIndex=ivector(1,clusterIndex-1);
	for(i=1;i<clusterIndex;i++) {clusterCount[i]=0; clusterCountIndex[i]=i;}
	for(i=1;i<=seqNum;i++) if(cluster[i]>=0) clusterCount[cluster[i]]++;
	for(i=1;i<clusterIndex-1;i++) for(j=i+1;j<clusterIndex;j++) if(clusterCount[i]<clusterCount[j])
	{	int tmpCluster=clusterCount[i]; int tmpClusterIndex=clusterCountIndex[i];
		clusterCount[i]=clusterCount[j]; clusterCountIndex[i]=clusterCountIndex[j];
		clusterCount[j]=tmpCluster; clusterCountIndex[j]=tmpClusterIndex;
	}

	for(i=1;i<clusterIndex;i++) fprintf(output1,"%d\n",clusterCount[i]);
	int outputScope;
	if(pickItem==1) outputScope=2;
	else if(pickItem==2) outputScope=3;
	else if(pickItem==3) outputScope=4;
	else if(pickItem==4) outputScope=5;
	int outputScopeCopy=outputScope;
	if(outputScope>=clusterIndex-1) outputScope=clusterIndex-1;
	else {
		while(clusterCount[outputScope]==clusterCount[outputScope+1]) {
			outputScope++;
			if(outputScope==clusterIndex-1) break;
		}
	}

	fprintf(output1,"clusterIndex:%d\n",clusterIndex);
	for(i=1;i<clusterIndex;i++){
		fprintf(output1,"Cluster %3d : ",clusterCountIndex[i]);
		for(j=1;j<=seqNum;j++)	if(cluster[j]==clusterCountIndex[i]) fprintf(output1,"%3d ",j);
		fprintf(output1,"\n");
	}
	for(j=1;j<=seqNum;j++) if(cluster[j]==0) fprintf(output1,"Cluster   0: %3d\n",j);
//	clusterNumber=clusterIndex-1;
	if(outputScope>=outputScopeCopy) for(j=1;j<=seqNum;j++) if(cluster[j]==0) clusterNumber--;
	fprintf(output1,"Total cluster number: %d\n",clusterNumber);

	//redefine siteFlag
	for(i=1;i<=seqLength;i++) siteFlag[i]=false;
	for(j=1;j<=seqLength;j++){
		int count=0;
		for(i=1;i<=seqNum;i++){
			if(cluster[i]>0){
				if(node[i].seq_aa[j]=='.' || node[i].seq_aa[j]=='-') count++;
			}
		}
		if(2*count>clusterNumber) siteFlag[j]=true;
	}
//	strcat(outFile1,"_2.aln");
//	output1=fopen(outFile1,"w");
	fprintf(output1,"%20s ",node[0].nodeName);
	for(j=1;j<=seqLength;j++)
		fprintf(output1,"%c",node[0].seq_aa[j]);
	fprintf(output1,"\n");

	for(i=1;i<=outputScope;i++){
		for(j=1;j<groupIndex[clusterCountIndex[i]];j++){
			fprintf(output1,"%20s ",node[group[clusterCountIndex[i]][j]].nodeName);
			for(k=1;k<=seqLength;k++)
				fprintf(output1,"%c",node[group[clusterCountIndex[i]][j]].seq_aa[k]);
			fprintf(output1,"\n");
		}
	}
/*	for(i=1;i<=seqNum;i++){
		if(cluster[i]>0){
			fprintf(output1,"%20s ",node[i].nodeName);
			for(j=1;j<=seqLength;j++)
				fprintf(output1,"%c",node[i].seq_aa[j]);
			fprintf(output1,"\n");
		}
	}
*/
	fclose(output1);
	//output *_1.aln
	output=fopen(alnFile,"w");
	for(i=1;i<=outputScope;i++){
		for(j=1;j<groupIndex[clusterCountIndex[i]];j++){
			char tmpChar[20];
			if(strlen(node[group[clusterCountIndex[i]][j]].nodeName)>14) node[group[clusterCountIndex[i]][j]].nodeName[15]='\0';
			strcat(node[group[clusterCountIndex[i]][j]].nodeName,"$");
			sprintf(tmpChar,"%d",clusterCountIndex[i]);
			strcat(node[group[clusterCountIndex[i]][j]].nodeName,tmpChar);
			fprintf(output,"%20s ",node[group[clusterCountIndex[i]][j]].nodeName);
			for(k=1;k<=seqLength;k++){
				if(node[0].seq_aa[k]!='-'){
					if(node[group[clusterCountIndex[i]][j]].seq_aa[k]=='.')
						fprintf(output,"%c",'-');
					else fprintf(output,"%c",node[group[clusterCountIndex[i]][j]].seq_aa[k]);
				}
			}
			fprintf(output,"\n");
		}
	}
	if(outputScope<outputScopeCopy){
		for(i=1;i<=seqNum;i++){
			if(cluster[i]==0){
				if(strlen(node[i].nodeName)>14) node[i].nodeName[15]='\0';
				strcat(node[i].nodeName,"$0");
				fprintf(output,"%20s ",node[i].nodeName);
				for(k=1;k<=seqLength;k++){
					if(node[0].seq_aa[k]!='-'){
						if(node[i].seq_aa[k]=='.')
							fprintf(output,"%c",'-');
						else fprintf(output,"%c",node[i].seq_aa[k]);
					}
				}
				fprintf(output,"\n");
			}
		}
	}

/*
	for(i=1;i<=seqNum;i++){
		if(cluster[i]>0){
			if(strlen(node[i].nodeName)>14) node[i].nodeName[15]='\0';
			strcat(node[i].nodeName,"$");
			strcat(node[i].nodeName,itoa(cluster[i]));
			fprintf(output,"%20s ",node[i].nodeName);
			for(j=1;j<=seqLength;j++){
//				if(!siteFlag[j]) {
				if(node[0].seq_aa[j]!='-'){
					if(node[i].seq_aa[j]=='.')
						fprintf(output,"%c",'-');
					else fprintf(output,"%c",node[i].seq_aa[j]);
				}
			}
			fprintf(output,"\n");
		}
	}
*/
	fclose(output);

}


void chooseSeq1(char *listFile, int number)
{
	int i,j,k;
	int listIndex=1;
	char **listName;
	int *accordIndex;
	char outFile[20],outFile1[20],outFile2[20];
	listName=cmatrix(1,seqNum,1,25);
	FILE *output,*output1;
	for(i=0;i<20;i++){
		if(listFile[i]!='.') {
			outFile[i]=listFile[i];
		}
		else break;
	}
	strcpy(outFile1,outFile);
	strcpy(outFile2,outFile);

	ifstream input;
	input.open(listFile,ios::in);
	for(i=1;i<=seqNum;i++){
		listIndex=i;
		input>>listName[i];
		if(strcmp(listName[i],"")==0) break;
	}
	input.close();
	cout<<"finishing reading list name"<<endl;
	accordIndex=ivector(1,listIndex-1);
	for(i=1;i<listIndex;i++){
		bool tmpFlag=false;
		for(j=1;j<=seqNum;j++){
			if(strcmp(listName[i],node[j].nodeName)==0){
				accordIndex[i]=j;
				tmpFlag=true;
				break;
			}
		}
		if(!tmpFlag) { printf("sequence: %s can not find according sequence\n",listName[i]); exit(0); }
	}

	//calculate the identity matrix
	double **idMatrix;
	idMatrix=dmatrix(1,listIndex-1,1,listIndex-1);
	for(i=1;i<listIndex-1;i++){
		for(j=i+1;j<=listIndex-1;j++){
			int count=0; int length=0;
			for(k=1;k<=seqLength;k++){
				if(((node[accordIndex[i]].seq_aa[k]!='-')&&(node[accordIndex[i]].seq_aa[k]!='.'))&&((node[accordIndex[j]].seq_aa[k]!='-')&&(node[accordIndex[j]].seq_aa[k]!='.')))
				{
					length++;
					if(node[accordIndex[i]].seq_aa[k]==node[accordIndex[j]].seq_aa[k]) count++;
				}
			}
			if(length>0) idMatrix[i][j]=1.0*count/length;
			else idMatrix[i][j]=0.0;
		}
	}
	for(i=1;i<listIndex-1;i++) for(j=i+1;j<=listIndex-1;j++) idMatrix[j][i]=idMatrix[i][j];
	for(i=1;i<=listIndex-1;i++) idMatrix[i][i]=0.0;
	//test
/*	for(i=1;i<=listIndex-1;i++){
		printf("%20s ",listName[i]);
		for(j=1;j<=listIndex-1;j++) printf("%3.0f",idMatrix[i][j]*100.0);
		printf("\n");
	}
*/
	double *idvector;
	idvector=dvector(1,listIndex-1);
	int *idIndex;
	idIndex=ivector(1,listIndex-1);
	for(i=1;i<=listIndex-1;i++){
		idvector[i]=0.0; idIndex[i]=i;
		for(j=1;j<=listIndex-1;j++){
			if(j!=i) idvector[i]+=idMatrix[i][j];
		}
		idvector[i]/=(listIndex-2);
//		printf("%-20s  %d\n", listName[i],(int) (idvector[i]*100.0));
	}

	//sort idvector
	for(i=1;i<listIndex-1;i++){
		for(j=i+1;j<=listIndex-1;j++){
			if(idvector[i]<idvector[j]){
				double tmpvector=idvector[i]; int tmpIndex=idIndex[i];
				idvector[i]=idvector[j]; idIndex[i]=idIndex[j];
				idvector[j]=tmpvector; idIndex[j]=tmpIndex;
			}
		}
	}
	if(number>listIndex-1) {
		printf("WARNING: sample base is smaller than your expectation\n");
		number=listIndex-1;
	}
	if(idvector[number]<0.26) {
		while(idvector[number]<0.26){
			number--;
		}
	}
	bool *siteFlag;
	siteFlag=new bool [seqLength+1];
	for(i=1;i<=seqLength;i++){
		int count=0; siteFlag[i]=false;
		for(j=1;j<=number;j++){
			if((node[accordIndex[idIndex[j]]].seq_aa[i]=='-')||(node[accordIndex[idIndex[j]]].seq_aa[i]=='.')) count++;
		}
		if(2*count>number) siteFlag[i]=true;
	}

	//output
	strcat(outFile,"_1.aln");
	output=fopen(outFile,"w");
	for(i=1;i<=number;i++){
		fprintf(output,"%20s ",node[accordIndex[idIndex[i]]].nodeName);
		for(j=1;j<=seqLength;j++){
			if(!siteFlag[j]) {
				if(node[accordIndex[idIndex[i]]].seq_aa[j]=='.')
					fprintf(output,"%c",'-');
				else fprintf(output,"%c",node[accordIndex[idIndex[i]]].seq_aa[j]);
			}
		}
		fprintf(output,"\n");
	}
	fclose(output);
	strcat(outFile1,"_2.aln");
	output1=fopen(outFile1,"w");
	for(i=1;i<=number;i++){
		fprintf(output1,"%20s ",node[accordIndex[idIndex[i]]].nodeName);
		for(j=1;j<=seqLength;j++)
			fprintf(output1,"%c",node[accordIndex[idIndex[i]]].seq_aa[j]);
		fprintf(output1,"\n");
	}
	fclose(output1);

	//statistics analysis for mean, var, max, min, histograph
	int *binCount;
	double *bin;
	bin=dvector(1,11);
	binCount=ivector(1,10);
	for(i=1;i<=10;i++) binCount[i]=0;
	double mean=0.0, var=0.0, max=-0.1, min=101.0;
	for(i=1;i<number-1;i++){
		for(j=i+1;j<=number;j++){
			if(idMatrix[idIndex[i]][idIndex[j]]>max) max=idMatrix[idIndex[i]][idIndex[j]];
			if(idMatrix[idIndex[i]][idIndex[j]]<min) min=idMatrix[idIndex[i]][idIndex[j]];
			mean+=idMatrix[idIndex[i]][idIndex[j]];
		}
	}
	mean=mean/(number*(number-1)/2);
	bin[1]=min; bin[11]=max;
	for(i=2;i<=10;i++) bin[i]=bin[i-1]+(max-min)/10.0;
	for(i=1;i<number-1;i++){
		for(j=i+1;j<=number;j++){
			var+=(idMatrix[idIndex[i]][idIndex[j]]-mean)*(idMatrix[idIndex[i]][idIndex[j]]-mean);
			for(k=1;k<=10;k++){
				if((idMatrix[idIndex[i]][idIndex[j]]>bin[k])&&(idMatrix[idIndex[i]][idIndex[j]]<bin[k+1])) {
					binCount[k]++;
					break;
				}
			}
		}
	}
	var=sqrt(var/(number*(number-1)/2-1));
	//find the biggest binCount then normalize
	int binMax=binCount[1];
	for(i=2;i<=10;i++) if(binCount[i]>binMax) binMax=binCount[i];
	for(i=1;i<=10;i++) binCount[i]=binCount[i]*100/binMax;
	//output
	strcat(outFile2,".his");
	output=fopen(outFile2,"w");
	fprintf(output,"%s\n",outFile2);
	fprintf(output,"Mean: %3.0f\nVariance: %3.0f\nMax Value: %3.0f\nMin Value: %3.0f\n",mean*100,var*100,max*100,min*100);
	fprintf(output,"Histograph:\n");
	for(i=1;i<=10;i++){
		fprintf(output,"bin%2d(%2.0f) ",i,(100*(bin[i+1]+bin[i])/2));
		for(j=1;j<=binCount[i];j++) fprintf(output,"=");
		fprintf(output,"\n");
	}
	fprintf(output,"\n\n");
	for(i=1;i<=number;i++)	fprintf(output,"%-20s  %d\n", listName[idIndex[i]],(int) (idvector[i]*100.0));

	fclose(output);

	free_dvector(bin,1,11);
	free_ivector(binCount,1,10);

}


void chooseSeq(char *listFile, int number)
{
	double ran1(long *idum);

	int i,j;
	char **listName;
	char **chosenName;
	int *chosenIndex;
	int listIndex=1;
	bool *siteFlag;
	char outFile[20],outFile1[20];
	siteFlag=new bool [seqLength+1];
	listName=cmatrix(1,seqNum,1,25);
	chosenName=cmatrix(1,number,1,25);
	chosenIndex=ivector(1,number);
	ifstream input;
	FILE *output,*output1;
	input.open(listFile,ios::in);
	for(i=1;i<=seqNum;i++){
		listIndex=i;
		input>>listName[i];
		if(strcmp(listName[i],"")==0) break;
	}
	input.close();
	cout<<"finishing reading list name"<<endl;
	cout<<"the number you choose:"<<number<<endl;
	int ranIndex=1;
	if(number<listIndex-1){
		while(ranIndex<=number){
			int tmpIndex=(int) (ran1(&idum)*(listIndex-1)+1.0);
	//		cout<<"tmpIndex:"<<tmpIndex<<"   ranIndex:"<<ranIndex<<endl;
	//		getchar();
			bool tmpFlag=false;
			for(i=1;i<ranIndex;i++) {
				if(strcmp(listName[tmpIndex],chosenName[i])==0) { tmpFlag=true; break;}
			}
			if(!tmpFlag){
				strcpy(chosenName[ranIndex],listName[tmpIndex]);
				ranIndex++;
			}
		}
	}
	else{
		number=listIndex-1;
		for(i=1;i<=number;i++) strcpy(chosenName[i],listName[i]);
	}
	cout<<"actual number:"<<number<<endl;
	cout<<"finish choosing sequence\n";
	for(i=1;i<=number;i++){
		bool testFlag=false;
		for(j=1;j<=seqNum;j++){
			if(strcmp(chosenName[i],node[j].nodeName)==0){
				chosenIndex[i]=j;
				testFlag=true;
				break;
			}
		}
		if(!testFlag) printf("%s chosenName[i] did not find its sequence\n");
	}
	for(i=1;i<=seqLength;i++){
		int count=0;
		for(j=1;j<=number;j++){
			if((node[chosenIndex[j]].seq_aa[i]=='-')||(node[chosenIndex[j]].seq_aa[i]=='.')) count++;
		}
		if(2*count>=number) siteFlag[i]=true;
	}
	for(i=0;i<20;i++){
		if(listFile[i]!='.') {
			outFile[i]=listFile[i];
		}
		else break;
	}
	strcpy(outFile1,outFile);
	strcat(outFile,"_1.aln");
//	cout<<"outFile:"<<outFile<<endl;
	output=fopen(outFile,"w");
	for(i=1;i<=number;i++){
		fprintf(output,"%20s ",node[chosenIndex[i]].nodeName);
		for(j=1;j<=seqLength;j++){
			if(!siteFlag[j]) {
				if(node[chosenIndex[i]].seq_aa[j]=='.')
					fprintf(output,"%c",'-');
				else fprintf(output,"%c",node[chosenIndex[i]].seq_aa[j]);
			}
		}
		fprintf(output,"\n");
	}
	fclose(output);
//	strcpy(outFile," ");
	strcat(outFile1,"_2.aln");
//	cout<<"outFile1:"<<outFile1<<endl;
	output1=fopen(outFile1,"w");
	for(i=1;i<=number;i++){
		fprintf(output1,"%20s ",node[chosenIndex[i]].nodeName);
		for(j=1;j<=seqLength;j++)
			fprintf(output1,"%c",node[chosenIndex[i]].seq_aa[j]);
		fprintf(output1,"\n");
	}
	fclose(output1);

//	cout<<"listIndex:"<<listIndex<<endl;
//	for(i=1;i<listIndex;i++) cout<<listName[i]<<endl;
//	cout<<"ranIndex:"<<ranIndex<<endl;
//	for(i=1;i<ranIndex;i++) cout<<chosenName[i]<<endl;
}


static char str[MAXSTR+1];

char **aname, **aseq;
int nal, alilen, *astart, *alen;


static char *mymalloc(int size)
//int size;
{
	char *buf;

	if ((buf = (char *)malloc((size_t) (size*sizeof(char)))) == NULL) {
		fprintf(stderr, "Not enough memory: %d\n", size);
		exit(1);
	}
	return buf;
}

char *ccvector(long nl, long nh)
/* allocate an char vector with subscript range v[nl..nh] */
{
	char *v;

	v=(char *)malloc((size_t) ((nh-nl+1+NR_END)*sizeof(char)));
	if (!v) nrerror("allocation failure in cvector()");
	return v-nl+NR_END;
}

char *strsave(char *str)
//char *str;
{
	char *buf;
	int l;

	l = strlen(str);
	buf = mymalloc(l + 1);
//	buf=ccvector(0,l+1);
	strcpy(buf, str);
	return buf;
}

char *strnsave(char *str, int l)
//char *str;
//int l;
{
	char *buf;

	buf = mymalloc(l + 1);
//	buf=ccvector(0,l+1);
	memcpy(buf, str, l);
	buf[l] = '\0';
	return buf;
}

static char **incbuf(int n, char **was)
{
	char **buf;
	buf = (char **) malloc((size_t) (n+1) * sizeof(buf[0]));
	if(!buf) {fprintf(stderr, "Not enough memory: %d\n",n+1); exit(1); }
//	buf=cmatrix(0,(n+1),0,(n+1));
	if (n > 0) {
		memcpy(buf, was, n * sizeof(was[0]));
		free(was);
	}
	buf[n] = NULL;
	return buf;
}

static int *incibuf(int n, int *was)
//int n, *was;
{
	int *ibuf;

	ibuf = (int *) malloc((size_t) (n+1) * sizeof(int));
	if(!ibuf) {fprintf(stderr, "Not enough memory: %d\n",n+1); exit(1); }
//	ibuf=ivector(0,(n+1)*sizeof(ibuf[0]));
	if (n > 0) {
		memcpy(ibuf, was, n * sizeof(was[0]));
		free(was);
	}
	ibuf[n] = 0;
	return ibuf;
}


void readali(char *filename)
/* fills alignment from the file *filename to
nal - number of sequences in the alignment;
alilen - alignment length;
aname[0..nal-1][0..until '\0'] - names of sequences;
aseq[0..nal-1][0..alilen-1] - sequences;
astart[0..nal-1] - starting residue number;
alen[0..nal-1] - sequence length;
*/

{
	FILE *fp;
	char *s, *ss, *seqbuf;
	int i,j,k, n, l, len, len0;
	int ii,mark=1;

	printf("Reading sequences\n");
	if ((fp = fopen(filename, "r")) == NULL) {
		fprintf(stderr, "No such file: \"%s\"\n", filename);
//		err_readali(1);
		exit(1);
	}
	alilen = 0;
	nal = 0;
	n = 0;
	if(fgets(str, MAXSTR, fp) != NULL) {
		if(strncmp(str,"CLUSTAL W",9)!=0){rewind(fp);}
					   }
	while (fgets(str, MAXSTR, fp) != NULL) {
		for (ss = str; isspace(*ss); ss++) ;
//		printf("SS1:%s\n",ss);
		if ((ii<=ss-str)&&(mark==0)) {continue;}
		if (*ss == '\0') {
			if (n == 0) {
				continue;
			}
			if (nal == 0) {
				if (n == 0) {
					fprintf(stderr, "No alignments read\n");
//					err_readali(2);
					exit(1);
				}
				nal = n;
			} else if (n != nal) {
				fprintf(stderr, "Wrong nal, was: %d, now: %d\n", nal, n);
//				err_readali(3);
				exit(1);
			}
			n = 0;
			continue;
		}
		for (s = ss; *s != '\0' && !isspace(*s); s++) ;
//		printf("S1:%s\n",s);
		*s++ = '\0';
		if (nal == 0) {
			astart = incibuf(n, astart);
			alen = incibuf(n, alen);
			aseq = incbuf(n, aseq);
			aname = incbuf(n, aname);
			aname[n] = strsave(ss);
		} else {
			if (n < 0 || n >= nal) {
				fprintf(stderr, "Bad sequence number: %d of %d\n", n, nal);
//				err_readali(4);
				exit(1);
			}
			if (strcmp(ss, aname[n]) != 0) {
				fprintf(stderr, "Names do not match");
				fprintf(stderr, ", was: %s, now: %s\n", aname[n], ss);
//				err_readali(5);
				exit(1);
			}
		}
		for (ss = s; isspace(*ss); ss++);
//		printf("SS2:%s\n",ss);
		if(mark==1){
		ii = ss-str;
		mark=0;}

		for (s = ss; isdigit(*s); s++) ;
//		printf("S2:%s\n",s);
		if (isspace(*s)) {
			if (nal == 0) {
				astart[n] = atoi(ss);
			}
			for (ss = s; isspace(*ss); ss++);
		}
		for (s = ss, l = 0; *s != '\0' && !isspace(*s); s++) {
			if (isalpha(*s)) {
				l++;
			}
		}
		len = s - ss;
//		printf("n:%d  nal:%d\n",n,nal);
		if (n == 0) {
			len0 = len;
			alilen += len;
		} else if (len != len0) {
			fprintf(stderr, "wrong len for %s", aname[n]);
			fprintf(stderr, ", was: %d, now: %d\n", len0, len);
//			err_readali(6);
			exit(1);
		}
		alen[n] += l;
		if (aseq[n] == NULL) {
			aseq[n] = strnsave(ss, len);
		} else {
//			printf("save sequence\n");
//			seqbuf=ccvector(0,alilen);
			seqbuf=mymalloc(alilen+1);
			memcpy(seqbuf, aseq[n], alilen-len);
			free(aseq[n]);
			aseq[n] = seqbuf;
			memcpy(seqbuf+alilen-len, ss, len);
			seqbuf[alilen] = '\0';
//			printf("after save sequence\n");
		}
		n++;
	}
	if (nal == 0) {
		if (n == 0) {
			fprintf(stderr, "No alignments read\n");
//			err_readali(7);
			exit(1);
		}
		nal = n;
	} else if (n != 0 && n != nal) {
		fprintf(stderr, "Wrong nal, was: %d, now: %d\n", nal, n);
//		err_readali(8);
		exit(1);
	}
	fclose(fp);
//	nal=n;

//	printf("n=%d alilen=%d nal=%d\n",n,alilen,nal);
	//define new structures
	seqNum=nal; seqLength=alilen;
//	int DIM=(seqNum-1)*2+1;
//	node=new NODE [DIM];
	int DIM=seqNum+1;
	node=new NODE [seqNum+1];
	for(i=0;i<DIM;i++) {
		node[i].seq_aa=new char [seqLength+2];
		node[i].seq_num=new int [seqLength+1];
		node[i].prob= dmatrix(1,seqLength+1,1,NP+1);
	}
	//transfer sequence to NODE structure
	for(i=1;i<=(seqNum*2-2);i++) node[i].nodeNum=i;
	for(i=1;i<=seqNum;i++) strcpy(node[i].nodeName,aname[i-1]);
	for(i=0;i<=seqNum/*DIM*/;i++) { node[i].seq_aa[0]=' ';node[i].seq_aa[seqLength+1]='\0';}
//	for(i=0;i<seqNum;i++) printf("%s\n",aseq[i]);
	for(i=1;i<=seqNum;i++) for(j=1;j<=seqLength;j++) node[i].seq_aa[j]=aseq[i-1][j-1];
	for(i=1;i<=seqNum;i++) for(j=1;j<=seqLength;j++) node[i].seq_aa[j]=toupper(node[i].seq_aa[j]);
	//deal with non-amino acid character
	for(i=1;i<=seqNum;i++){
		for(j=1;j<=seqLength;j++){
			bool flag=false;
			for(int k=0;k<=NP;k++) if(node[i].seq_aa[j]==aa[k]) flag=true;
			if(!flag) node[i].seq_aa[j]='-';
		}
	}
	//compare sequence name to find duplicates
	printf("try to find the duplicate name of different sequences\n");
	bool dupFlag=false;
	for(i=1;i<seqNum;i++){
		for(j=i+1;j<=seqNum;j++){
			if(strcmp(node[i].nodeName, node[j].nodeName)==0){
				dupFlag=true;
				printf("duplication: seqNo:%d seqName:%s  seqNo:%d seqName:%s\n",i,node[i].nodeName,j,node[j].nodeName);
			}
		}
	}
	if(dupFlag) exit(1);

	//put template sequence into node[0]
	for(i=0;i<=seqNum-1;i++) node[i]=node[i+1];
	seqNum--;
//	printf("seqNum:%d\n",seqNum);
	//find the template sequence non gap length
	int stdLength=0;
	for(i=1;i<=seqLength;i++) if(node[0].seq_aa[i]!='-') stdLength++;
	//find those sequences that can not cover 80% of template sequence non-gap position
	int *lengthDist; lengthDist=ivector(1,seqNum);
	for(i=1;i<=seqNum;i++){
		lengthDist[i]=0;
		for(j=1;j<=seqLength;j++){
			if(node[0].seq_aa[j]!='-'){
				if(node[i].seq_aa[j]!='-') lengthDist[i]++;
			}
		}
		lengthDist[i]=lengthDist[i]*100/stdLength;
	}
	//histogram
	int *binCount;
	binCount=ivector(1,20);
	for(i=1;i<=20;i++) binCount[i]=0;
	for(i=1;i<=seqNum;i++){
			for(k=0;k<=19;k++){
				if((lengthDist[i]>=k*5)&&(lengthDist[i]<(k+1)*5)) {
					binCount[k+1]++;
					break;
				}
				else if(lengthDist[i]>95) {
					binCount[20]++;
					break;
				}
			}

	}
//	for(i=1;i<=20;i++) printf("%5d\n",binCount[i]);
	//delete sequence
	for(i=1;i<=seqNum;i++){
		if(lengthDist[i]<75){
			while(lengthDist[seqNum]<75) { seqNum--;}
			node[i]=node[seqNum];
			seqNum--;

		}
	}
	//delete gap sites
	for(i=1;i<=seqLength;i++){
		if(node[0].seq_aa[i]=='-' || node[0].seq_aa[i]=='.'){
			if(i==seqLength) seqLength--;
			else {
				for(j=0;j<=seqNum;j++) for(k=i;k<seqLength;k++) node[j].seq_aa[k]=node[j].seq_aa[k+1];
				i=i-1; seqLength--;
			}
		}
	}
	//assign seq_num
	for(i=1;i<=seqNum;i++){
		for(j=1;j<=seqLength;j++) {
			for(k=0;k<=NP;k++) {
				if(node[i].seq_aa[j]==aa[k]) {node[i].seq_num[j]=k; break;}
			}
		}
	}

	alfa= dvector(0,seqLength);
	//assign alfa vector
	for(i=1;i<=seqLength;i++) alfa[i]=1.0;

}


char *itoa(int b)
{
	char *convert;
	int count=0,copy,c,index=0,d;
	copy= b;
	while(copy>0){
		count++;
		copy/=10;
	}
	convert= new char [count+1];
	for(int i=count;i>=0;i--)
	{	d=1;
		for(int j=0;j<i;j++) d=d*10;
		c=b/d;
		b=b-c*d;
		if(c>0)
		{
			if(c==1) convert[index]='1';
			else if(c==2) convert[index]='2';
			else if(c==3) convert[index]='3';
			else if(c==4) convert[index]='4';
			else if(c==5) convert[index]='5';
			else if(c==6) convert[index]='6';
			else if(c==7) convert[index]='7';
			else if(c==8) convert[index]='8';
			else if(c==9) convert[index]='9';
			index++;
		}
		else if(c==0)
		{
			if(index>0)
			{
				convert[index]='0';
				index++;
			}
		}
	}
	convert[index]='\0';
	return convert;
}


void cal_PI()
{
	int i,j,k;
	int totalAA=0, aaNum[NP+1];//used for calculating PI vector
	//calculate PI vector
	for(i=0;i<=NP;i++) aaNum[i]=0;
	for(i=1;i<=seqNum;i++){
		for(j=1;j<=seqLength;j++){
			if(calFlag[j]) { 
				if(node[i].seq_num[j]<0 || node[i].seq_num[j]>20) printf("%d %d %d\n",i,j,node[i].seq_num[j]);
				aaNum[node[i].seq_num[j]]++; if(node[i].seq_num[j]>0) totalAA++;
			 }
		}
	}
	for(i=1;i<=NP;i++){
		PI[i]=1.0*aaNum[i]/totalAA;
	}
}


void cal_Q(double *pi)
{
	int i,j,k;
	double normalization;//used for Q matrix normalization
//	printf("sequence number: %d  sequence length: %d\n",seqNum,seqLength);
	//calculate Q_ij
	for(i=1;i<=NP;i++){
		for(j=1;j<=NP;j++) Q_ij[i][j]=S_ij[i][j]*pi[j];
	}
	//calculate Q_ii
	for(i=1;i<=NP;i++){
		Q_ij[i][i]=0.0;
		for(j=1;j<=NP;j++){
			if(j!=i) Q_ij[i][i]+=(-1.0)*Q_ij[i][j];
		}
	}
/*
	printf("Q_ij Matrix (before normalization) :\n");
	for(i=1;i<=NP;i++){
		for(j=1;j<=NP;j++) printf("%15.8f ",Q_ij[i][j]);
		printf("\n");
	}
*/
	//normalize Q_ij
	normalization=0.0;
	for(i=1;i<=NP;i++){
		normalization+=(-1.0)*pi[i]*Q_ij[i][i];
	}
	
	for(i=1;i<=NP;i++){
		for(j=1;j<=NP;j++) Q_ij[i][j]=Q_ij[i][j]/normalization;
	}
	//used for test, print some result
/*	printf("S_ij Matrix:\n");
	for(i=1;i<=NP;i++){
		for(j=1;j<=NP;j++) printf("%12.8f",S_ij[i][j]);
		printf("\n");
	}
	printf("PI Vector:\n");
	for(i=1;i<=NP;i++) printf("%12.8f",PI[i]);
	printf("\n");
	printf("Normalization: %10.8f\n",normalization);
	printf("Q_ij Matrix (after normalization) :\n");
	for(i=1;i<=NP;i++){
		for(j=1;j<=NP;j++) printf("%15.8f ",Q_ij[i][j]);
		printf("\n");
	}
*/
}

void cal_Eign()
{
	int i,j,k;
	double wmax,wmin;//used for SVD algo
	double d=0.0; //used for finding inverse matrix
	int *indx;
	double check[NP+1][NP+1];
	double norSVD; //used for normalize eignvector matrix

	//calculate eignvalue
	for(i=1;i<=NP;i++) for(j=1;j<=NP;j++) a[i][j]=Q_ij[i][j];
	balanc(a,NP);
	elmhes(a,NP);
	hqr(a,NP,wr,wi);
/*
	cout<<"The eignvalue\n";
	for(i=1;i<=NP;i++) printf("%15.8f ",wr[i]);
	printf("\n");
*/
	//calculate eignvectors use SVD algo
//	printf("The eignvector matrix:\n");
	for(k=1;k<=NP;k++){
		for(i=1;i<=NP;i++) for(j=1;j<=NP;j++) a[i][j]=Q_ij[i][j];
		for(i=1;i<=NP;i++) a[i][i]-=wr[k];
		svdcmp(a,NP,NP,w,svdv);
		wmax=0.0;
		for(i=1;i<=NP;i++) if(w[i]>wmax) wmax=w[i];
		wmin=wmax*(1.0e-6);
		for(i=1;i<=NP;i++) if((w[i]<wmin)&&(w[i]>(-1.0*wmin))){
			for(j=1;j<=NP;j++) v[j][k]=svdv[j][i];
		}
		norSVD=0.0;
		for(i=1;i<=NP;i++) norSVD+=v[i][k];
		for(i=1;i<=NP;i++) v[i][k]=v[i][k]/norSVD;
	}
/*
	printf("Matrix of eignvector matrix\n");
	for(i=1;i<=NP;i++) {
		for(j=1;j<=NP;j++) printf("%15.6e ",v[i][j]);
		printf("\n\n");
	}
*/
	//calcuate inverse of eignvector matrix
	indx=ivector(1,NP);
	for(i=1;i<=NP;i++) for(j=1;j<=NP;j++) a[i][j]=v[i][j];
	ludcmp(a,NP,indx,&d);
	for(j=1;j<=NP;j++){
		for(i=1;i<=NP;i++) colu[i]=0.0;
		colu[j]=1.0;
		lubksb(a,NP,indx,colu);
		for(i=1;i<=NP;i++) inv[i][j]=colu[i];
	}
/*
	printf("Inverse matrix of eignvector matrix\n");
	for(i=1;i<=NP;i++) {
		for(j=1;j<=NP;j++) printf("%15.6e ",inv[i][j]);
		printf("\n\n");
	}
*/
	//check if the eignvector matrix is correct
/*
	for(i=1; i<=NP; i++) for(j=1; j<=NP; j++) check[i][j]=0.0;
	for(k=1;k<=NP;k++) {
		for(i=1;i<=NP;i++) for(j=1;j<=NP;j++) a[i][j]=Q_ij[i][j];
		for(i=1;i<=NP;i++) a[i][i]-=wr[k];
		for(j=1;j<=NP;j++){
			for(i=1;i<=NP;i++){
				check[j][k]+=a[j][i]*v[i][k];
			}
		}
	}
	printf("the check matrix for eignvector\n");
	for(i=1;i<=NP;i++) {
		for(j=1;j<=NP;j++) printf("%15.6e ",check[i][j]);
		printf("\n\n");
	}

	//check if the inverse matrix is correct
	for(i=1; i<=NP; i++) for(j=1; j<=NP; j++) check[i][j]=0.0;
	for(i=1; i<=NP; i++) 
		for(j=1; j<=NP; j++) 
			for(k=1; k<=NP; k++){
				check[i][j]+=v[i][k]*inv[k][j];
			}
	printf("the check matrix for inverse\n");
	for(i=1;i<=NP;i++) {
		for(j=1;j<=NP;j++) printf("%15.6e ",check[i][j]);
		printf("\n");
	}

    //check if the Q=U*lenta*invU
    double **check1; check1=dmatrix(1,NP,1,NP);
    for(i=1;i<=NP;i++) for(j=1;j<=NP;j++) { check[i][j]=0.0; check1[i][j]=0.0; }
    for(i=1;i<=NP;i++) for(j=1;j<=NP;j++) check1[i][j]=v[i][j]*wr[j];
    for(i=1; i<=NP; i++)
            for(j=1; j<=NP; j++)
                    for(k=1; k<=NP; k++){
                            check[i][j]+=check1[i][k]*inv[k][j];
                    }
    printf("the check matrix for Q\n");
    for(i=1;i<=NP;i++) {
            for(j=1;j<=NP;j++) printf("%15.8f ",check[i][j]);
            printf("\n");
    }       
*/

}

void alpha()
{
	int i,j,k;
	int gapNum=0,pairNum;
	double *correlation,norCor=0.0;//, *alfa;
	double totalLikely;
	double **corP;//correlation matrix of P(ij)
	bool invariantFlag;
	int nongapIndex;

	correlation= new double [seqLength+1];
	corP=dmatrix(1,NP,1,NP);

		//find the correlation matrix (d=1.0 && Alfa=1.0) and make this matrix symmetric by Pij=(pij+pji)/2
		for(i=1;i<=NP;i++) for(j=1;j<=NP;j++) corP[i][j]=pij(i,j,1.0,1.0);
		for(i=1;i<=NP;i++) for(j=1;j<=i;j++) { 
			corP[i][j]=(corP[i][j]+corP[j][i])/2.0; corP[j][i]=corP[i][j]; 
		}

		//find the correlation vector
		for(i=1;i<=seqLength;i++){
			correlation[i]=0.0;
			if(calFlag[i]) {
				pairNum=0; //idSite=0.0;
				for(j=1;j<seqNum;j++){
					for(k=j+1;k<=seqNum;k++){
						//deal with gaps
						if((node[j].seq_num[i]!=0)&&(node[k].seq_num[i]!=0))
						{ correlation[i]+=corP[node[j].seq_num[i]][node[k].seq_num[i]]; /*idSite+=idMatrix[j][k];*/ pairNum++;}
					}
				}
				correlation[i]=pow(1.0*pairNum/correlation[i],1.3);
				norCor+=correlation[i];
			}
			else correlation[i]=0.0;
		}
		//set invariant site alfa=0.0
		for(i=1;i<=seqLength;i++){
			invariantFlag=true;
			if(calFlag[i]){
				//find the first non-gap sequence
				for(j=1;j<=seqNum;j++){
					if(node[j].seq_num[i]!=0) {nongapIndex=j;break;}
				}
				for(j=nongapIndex+1;j<=seqNum;j++){
					if((node[j].seq_num[i]!=node[nongapIndex].seq_num[i])&&(node[j].seq_num[i]!=0)){
						invariantFlag=false; break;
					}
				}
				if(invariantFlag){
					norCor-=correlation[i];
					correlation[i]=0.0;
					printf("invariant site: %d\n",i);
				}
				invariantFlag=true;
			}
			else alfa[i]=0.0;

		}

		//initial alfa vector
		for(i=1;i<=seqLength;i++) {
			if(calFlag[i]) { 
				correlation[i]=correlation[i]*(1.0*(seqLength-gapNum))/norCor;
				alfa[i]=correlation[i];
			}
		}
}

//calculate Pij(t)
//double pij(double **v,double **inv,double *wr,int s1,int s2,double d, double alfa)
double pij(int s1,int s2,double d, double alfa)
{
	int i;
	double pij_t=0.0;
	if((s2<1)||(s2>20)) {printf("Warning: can not calculate pij\n"); exit(0);}//return 1.0;
	if(PI[s2]<1.0e-10 && s1!=s2) return 0.0;
	for(i=1;i<=NP;i++){
//		pij_t+=v[s1][i]*inv[i][s2]*pow(E, d*alfa*wr[i]);
		pij_t+=v[s1][i]*inv[i][s2]*exp(d*alfa*wr[i]);
	}
	if((pij_t<0.0)&&(fabs(pij_t)<1.0e-12)) pij_t=0.0;
	return pij_t;
}

//double dist(int node1, int node2)
double dist(int node1, int node2)
{
	int i,j,JMAX=60;
	int **Nab;
	double xLeft,xRight,dx,xMid,xacc=0.000001;
	double leftBracket,rightBracket,midBracket;
	Nab=imatrix(1,2,1,seqLength);
	xLeft=0.000001;
	for(i=1;i<=seqLength;i++) Nab[1][i]=node[node1].seq_num[i];
	for(i=1;i<=seqLength;i++) Nab[2][i]=node[node2].seq_num[i];
	//find the two brackets
//	printf("node1:%d, node2:%d\n",node1,node2);
	leftBracket=functionValue(Nab,xLeft);
	if(fabs(leftBracket)<0.000001) {/*free_imatrix(Nab,0,NP,0,NP);*/ return xLeft;}
	xRight=1.0;
	rightBracket=functionValue(Nab,xRight);
//	printf("rightBracket:%8.5f\n",rightBracket);
	while((leftBracket*rightBracket)>0.0){
		xLeft=xRight; leftBracket=rightBracket;
		xRight+=1.0;
		rightBracket=functionValue(Nab,xRight);
		if((fabs(rightBracket)<1.0e-6)||(xLeft>=10.0)){
			printf("Warning:distance between %s and %s is inf, set distance 10.0\n",node[node1].nodeName,node[node2].nodeName);
//			free_imatrix(Nab,0,NP,0,NP);
			return 10.0;
		}
//		printf("in while, xLeft:%f, xRight:%f; leftBracket:%12.8f; rightBracket:%12.8f\n",xLeft,xRight,leftBracket,rightBracket);
//		getchar();
	}
//	printf("leftBracket:%8.5f; rightBracket:%8.5f\n",leftBracket,rightBracket);
	//use bisection to solve this function
	for(j=1;j<=JMAX;j++){
		dx=xRight-xLeft;
		xMid=xLeft+dx/2.0;
		midBracket=functionValue(Nab,xMid);
//		printf("xLeft:%12.8f xRight:%12.8f xMid:%12.8f\n",xLeft,xRight,xMid);
//		printf("left:%12.8f Right:%12.8f Mid:%12.8f\n",leftBracket,rightBracket,midBracket);
//		getchar();
		if(fabs(dx)<xacc || midBracket==0.0) { /*free_imatrix(Nab,0,NP,0,NP);*/ return xMid;}
		if((leftBracket*midBracket)>0.0) { leftBracket=midBracket; xLeft=xMid; }
		else if((rightBracket*midBracket)>0.0) { rightBracket=midBracket; xRight=xMid; }
	}
	printf("Too many iterations to find the distance between node:%d and node:%d\n",node1,node2);
//	free_imatrix(Nab,0,NP,0,NP);
	return 10.0;
}

double functionValue(int **Nab, double d)
{
	int i,j;
	double value=0.0;
	for(i=1;i<=seqLength;i++){
		if(Nab[1][i]!=0 && Nab[2][i]!=0 && alfa[i]>1.0e-8)
			value+=dpij(Nab[1][i],Nab[2][i],d,alfa[i])/pij(Nab[1][i],Nab[2][i],d,alfa[i]);
	}
	return value;
}

double dpij(int s1,int s2,double d, double alfa)
{
	int i;
	double pij_t=0.0;
	if((s2<1)||(s2>20)) { printf("Error in dpij function\n"); exit(1); }
	for(i=1;i<=NP;i++){
		pij_t+=v[s1][i]*inv[i][s2]*exp(d*alfa*wr[i])*wr[i]*alfa;
	}
	return pij_t;
}


void init_S()
{
	S_ij=dmatrix(1,NP,1,NP);
	int i,j;
	S_ij[2][1]=  0.551571;	S_ij[3][1]=  0.509848;	S_ij[3][2]=  0.635346;	S_ij[4][1]=  0.738998;	S_ij[4][2]=  0.147304;
	S_ij[4][3]=  5.429420;	S_ij[5][1]=  1.027040;	S_ij[5][2]=  0.528191;	S_ij[5][3]=  0.265256;	S_ij[5][4]=  0.030295;
	S_ij[6][1]=  0.908598;	S_ij[6][2]=  3.035500;	S_ij[6][3]=  1.543640;	S_ij[6][4]=  0.616783;	S_ij[6][5]=  0.098818;
	S_ij[7][1]=  1.582850;	S_ij[7][2]=  0.439157;	S_ij[7][3]=  0.947198;	S_ij[7][4]=  6.174160;	S_ij[7][5]=  0.021352;
	S_ij[7][6]=  5.469470;	S_ij[8][1]=  1.416720;	S_ij[8][2]=  0.584665;	S_ij[8][3]=  1.125560;	S_ij[8][4]=  0.865584;
	S_ij[8][5]=  0.306674;	S_ij[8][6]=  0.330052;	S_ij[8][7]=  0.567717;	S_ij[9][1]=  0.316954;	S_ij[9][2]=  2.137150;
	S_ij[9][3]=  3.956290;	S_ij[9][4]=  0.930676;	S_ij[9][5]=  0.248972;	S_ij[9][6]=  4.294110;	S_ij[9][7]=  0.570025;
	S_ij[9][8]=  0.249410;	S_ij[10][1]= 0.193335;	S_ij[10][2]= 0.186979;	S_ij[10][3]= 0.554236;	S_ij[10][4]= 0.039437;
	S_ij[10][5]= 0.170135;	S_ij[10][6]= 0.113917;	S_ij[10][7]= 0.127395;	S_ij[10][8]= 0.030450;	S_ij[10][9]= 0.138190;
	S_ij[11][1]= 0.397915;	S_ij[11][2]= 0.497671;	S_ij[11][3]= 0.131528;	S_ij[11][4]= 0.084805;	S_ij[11][5]= 0.384287;
	S_ij[11][6]= 0.869489;	S_ij[11][7]= 0.154263;	S_ij[11][8]= 0.061304;	S_ij[11][9]= 0.499462;	S_ij[11][10]=3.170970;
	S_ij[12][1]= 0.906265;	S_ij[12][2]= 5.351420;	S_ij[12][3]= 3.012010;	S_ij[12][4]= 0.479855;	S_ij[12][5]= 0.074034;
	S_ij[12][6]= 3.894900;	S_ij[12][7]= 2.584430;	S_ij[12][8]= 0.373558;	S_ij[12][9]= 0.890432;	S_ij[12][10]=0.323832;
	S_ij[12][11]=0.257555;	S_ij[13][1]= 0.893496;	S_ij[13][2]= 0.683162;	S_ij[13][3]= 0.198221;	S_ij[13][4]= 0.103754;
	S_ij[13][5]= 0.390482;	S_ij[13][6]= 1.545260;	S_ij[13][7]= 0.315124;	S_ij[13][8]= 0.174100;	S_ij[13][9]= 0.404141;
	S_ij[13][10]=4.257460;	S_ij[13][11]=4.854020;	S_ij[13][12]=0.934276;	S_ij[14][1]= 0.210494;	S_ij[14][2]= 0.102711;
	S_ij[14][3]= 0.096162;	S_ij[14][4]= 0.046730;	S_ij[14][5]= 0.398020;	S_ij[14][6]= 0.099921;	S_ij[14][7]= 0.081134;
	S_ij[14][8]= 0.049931;	S_ij[14][9]= 0.679371;	S_ij[14][10]=1.059470;	S_ij[14][11]=2.115170;	S_ij[14][12]=0.088836;
	S_ij[14][13]=1.190630;	S_ij[15][1]= 1.438550;	S_ij[15][2]= 0.679489;	S_ij[15][3]= 0.195081;	S_ij[15][4]= 0.423984;
	S_ij[15][5]= 0.109404;	S_ij[15][6]= 0.933372;	S_ij[15][7]= 0.682355;	S_ij[15][8]= 0.243570;	S_ij[15][9]= 0.696198;
	S_ij[15][10]=0.099929;	S_ij[15][11]=0.415844;	S_ij[15][12]=0.556896;	S_ij[15][13]=0.171329;	S_ij[15][14]=0.161444;
	S_ij[16][1]= 3.370790;	S_ij[16][2]= 1.224190;	S_ij[16][3]= 3.974230;	S_ij[16][4]= 1.071760;	S_ij[16][5]= 1.407660;
	S_ij[16][6]= 1.028870;	S_ij[16][7]= 0.704939;	S_ij[16][8]= 1.341820;	S_ij[16][9]= 0.740169;	S_ij[16][10]=0.319440;
	S_ij[16][11]=0.344739;	S_ij[16][12]=0.967130;	S_ij[16][13]=0.493905;	S_ij[16][14]=0.545931;	S_ij[16][15]=1.613280;
	S_ij[17][1]= 2.121110;	S_ij[17][2]= 0.554413;	S_ij[17][3]= 2.030060;	S_ij[17][4]= 0.374866;	S_ij[17][5]= 0.512984;
	S_ij[17][6]= 0.857928;	S_ij[17][7]= 0.822765;	S_ij[17][8]= 0.225833;	S_ij[17][9]= 0.473307;	S_ij[17][10]=1.458160;
	S_ij[17][11]=0.326622;	S_ij[17][12]=1.386980;	S_ij[17][13]=1.516120;	S_ij[17][14]=0.171903;	S_ij[17][15]=0.795384;
	S_ij[17][16]=4.378020;	S_ij[18][1]= 0.113133;	S_ij[18][2]= 1.163920;	S_ij[18][3]= 0.071917;	S_ij[18][4]= 0.129767;
	S_ij[18][5]= 0.717070;	S_ij[18][6]= 0.215737;	S_ij[18][7]= 0.156557;	S_ij[18][8]= 0.336983;	S_ij[18][9]= 0.262569;
	S_ij[18][10]=0.212483;	S_ij[18][11]=0.665309;	S_ij[18][12]=0.137505;	S_ij[18][13]=0.515706;	S_ij[18][14]=1.529640;
	S_ij[18][15]=0.139405;	S_ij[18][16]=0.523742;	S_ij[18][17]=0.110864;	S_ij[19][1]= 0.240735;	S_ij[19][2]= 0.381533;
	S_ij[19][3]= 1.086000;	S_ij[19][4]= 0.325711;	S_ij[19][5]= 0.543833;	S_ij[19][6]= 0.227710;	S_ij[19][7]= 0.196303;
	S_ij[19][8]= 0.103604;	S_ij[19][9]= 3.873440;	S_ij[19][10]=0.420170;	S_ij[19][11]=0.398618;	S_ij[19][12]=0.133264;
	S_ij[19][13]=0.428437;	S_ij[19][14]=6.454280;	S_ij[19][15]=0.216046;	S_ij[19][16]=0.786993;	S_ij[19][17]=0.291148;
	S_ij[19][18]=2.485390;	S_ij[20][1]= 2.006010;	S_ij[20][2]= 0.251849;	S_ij[20][3]= 0.196246;	S_ij[20][4]= 0.152335;
	S_ij[20][5]= 1.002140;	S_ij[20][6]= 0.301281;	S_ij[20][7]= 0.588731;	S_ij[20][8]= 0.187247;	S_ij[20][9]= 0.118358;
	S_ij[20][10]=7.821300;	S_ij[20][11]=1.800340;	S_ij[20][12]=0.305434;	S_ij[20][13]=2.058450;	S_ij[20][14]=0.649892;
	S_ij[20][15]=0.314887;	S_ij[20][16]=0.232739;	S_ij[20][17]=1.388230;	S_ij[20][18]=0.365369;	S_ij[20][19]=0.314730;

	//symmetrize S_ij
	for(i=1;i<=NP;i++){
		S_ij[i][i]=0.0;
		for(j=1;j<i;j++) S_ij[j][i]=S_ij[i][j];
	}
}
