#include <math.h>
#define JMAX 60

double drtbis(double (*func)(int,int,double,double), double x1, double x2, double xacc, int site, int root, double lenta)
{
	void nrerror(char error_text[]);
	int j;
	double dx,f,fmid,xmid,rtb;

	f=(*func)(site,root,x1,lenta);
	fmid=(*func)(site,root,x2,lenta);
	if (f*fmid >= 0.0) nrerror("Root must be bracketed for bisection in rtbis");
	rtb = f < 0.0 ? (dx=x2-x1,x1) : (dx=x1-x2,x2);
	for (j=1;j<=JMAX;j++) {
		fmid=(*func)(site,root,xmid=rtb+(dx *= 0.5),lenta);
		if (fmid <= 0.0) rtb=xmid;
		if (fabs(dx) < xacc || fmid == 0.0) return rtb;
	}
	nrerror("Too many bisections in rtbis");
	return 0.0;
}
#undef JMAX
/* (C) Copr. 1986-92 Numerical Recipes Software 21].,t45316. */
