/*__*
 *__*
 *__* WEIGHBOR 1.0.1
 *__*
 *__* Copyright (c) 1997-2000 
 *__*    Los Alamos National Laboratories
 *__*    The Rockefeller University
 *__*
 *__* This file is part of the WEIGHBOR program that can be used free of
 *__* charge in academic research and teaching. Any commercial use of
 *__* this software requires prior permission and possibly a license. For
 *__* commercial use contact: W. Bruno at billb@t10.lanl.gov Los Alamos
 *__* National Laboratories makes no representations about the
 *__* suitability of this software for any purpose. It is provided 
 *__* "as is" without express or implied warranty
 *__*	
 *__* For those using this program for research please use the following 
 *__* citation for this program:
 *__*
 *__*    Bruno, W. J., Socci, N. D. and Halpern, A. L., ``Weighted 
 *__*        Neighbor Joining: A Fast Approximation to Maximum-Likelihood
 *__*        Phylogeny Reconstruction,'' Molecular Biology and Evolution, 
 *__*        17(1): 189-197, (2000).
 *__*
 *__* 
 *__*/
/*
  
  \input cnoweb

  Program: weighbor                             \hfill\break
  File: io.h                                    \hfill\break
  Author: N. D. Socci                           \hfill\break
  Created: 6-Feb-97                             \hfill\break
  
  \title{io.h}
  \job{Weighbor}
  
  \synopsis{File I/O Routines}
  

  */

/* $Id: io.h,v 1.10 2000/01/12 00:49:33 nds Exp $ */

/*
  
  $Log: io.h,v $
  Revision 1.10  2000/01/12 00:49:33  nds
  Fixed copyright tags

  Revision 1.9  2000/01/06 05:50:34  nds
  Fixed copywrite notice (must be post-added with a script)

  Removed the HASH1 code

  Fixed assert redef warning

  Fixed roundoff error in sigma_na

  Can not read lower triagular matrices

  Revision 1.1.1.1  2000/01/05 19:47:29  nds
  Import to CVS

  Revision 1.3  1999/06/09 03:18:13  nds
  Historical Source 6-Jun-99

  Revision 1.12  1998/06/15 23:56:16  nds
  First Release Version!

  Revision 1.11  1998-06-09 18:33:39-04  nds
  Version 0.2.13
      Added -Xx option
      Changed the normalization on the -Xn option
      Copyright notice added to all files

  Revision 1.10  1997-09-18 16:55:42-04  nds
  Final 1.x version of weighbor. Uses approximate residual computation
  to calculate the pairs to join and averages the various branch lengths
  estimates to get the new branch lengths for the joinded pairs.

  Revision 1.1  1997-08-08 13:56:45-04  nds
  Initial revision


  */

#ifndef __IO_H
#define __IO_H

#include "matrix.h"

FILE * openRead(char *filename);
FILE * openWrite(char *filename);
void printError(char *);
int readPhylipFile(FILE *fp, int *N, MatrixT *D, char **names[]);

#endif /* __IO_H */

/* \endc */
